# MIT License
#
# Copyright (c) [2024] [https://pharmacy-near-me.com, https://www.healthporta.com]
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

import os
from pathlib import Path

## Configuration
POSTGRES_HOST = 'localhost'
DATABASE = "healthporta"
YOUR_POSTGRES_PORT = 5434
YOUR_POSTGRES_PGUSER = 'postgres'
YOUR_POSTGRES_PGPASSWORD = ''
POSTGRES_CONNECTION_EXTRA = '?sslmode=require'
LOCAL_PATH = "/gisdata"
SERVER_PSQL_BIN = '/usr/lib/postgresql/16/bin'
LOCAL_PSQL_BIN = '/usr/lib/postgresql/16/bin'
## /Configuration

CONNECTION_STRING = f"postgresql://{YOUR_POSTGRES_PGUSER}:{YOUR_POSTGRES_PGPASSWORD}@{POSTGRES_HOST}:{YOUR_POSTGRES_PORT}/{DATABASE}{POSTGRES_CONNECTION_EXTRA}"

STATES = ('debie', 'AK','AL','AR','AZ','CA','CO','CT','DE','FL','GA','HI','IA','ID','IL','IN','KS','KY','LA','MA','MD','ME','MI','MN','MO','MS','MT','NC','ND','NE','NH','NJ','NM','NV','NY', 'OH','OK','OR','PA','SC','SD','TN','TX','UT','VA','VT','WA','WI','WV','WY', 'PR', 'DC', 'RI', 'GU')

with open('all_import.sh', "w") as d:
    for i in STATES:
        if i == 'debie':
            file = f"nation_script_load.sh"
            script_stream = os.popen(
                f'psql {CONNECTION_STRING} -c "SELECT Loader_Generate_Nation_Script(\'debbie\')" -tA')
        else:
            file = f'state_load_{i}.sh'
            script_stream = os.popen(f'psql {CONNECTION_STRING} -c "SELECT Loader_Generate_Script(ARRAY[\'{i}\'], \'debbie\')" -tA')
        script = script_stream.read()
        Path(f'{LOCAL_PATH}/temp/').mkdir(parents=True, exist_ok=True)

        script = script.replace(f'PGBIN={SERVER_PSQL_BIN}', f'PGBIN={LOCAL_PSQL_BIN}')
        script = script.replace('PGPORT=5432', f'PGPORT=\'{YOUR_POSTGRES_PORT}\'')
        script = script.replace('PGUSER=postgres', f'PGUSER=\'{YOUR_POSTGRES_PGUSER}\'')
        script = script.replace('PGPASSWORD=yourpasswordhere', f'PGPASSWORD=\'{YOUR_POSTGRES_PGPASSWORD}\'')
        script = script.replace('PGDATABASE=geocoder', f'PGDATABASE={DATABASE}')
        script = script.replace('PGHOST=localhost', f'PGHOST={POSTGRES_HOST}')

        script = script.replace('cd /gisdata', f'cd {LOCAL_PATH}')

        with open(file, "w") as f:
            f.write(script)
        d.write(f"sh ./{file}\n")